Module java.base
Package java.time.chrono

## Class JapaneseEra

- java.lang.Object
- - java.time.chrono.JapaneseEra

All Implemented Interfaces:
  Serializable, Era, TemporalAccessor, TemporalAdjuster

    public final class JapaneseEra
    extends Object
    implements Era, Serializable

An era in the Japanese Imperial calendar system.

This class defines the valid eras for the Japanese chronology. Japan introduced the Gregorian calendar starting with Meiji 6. Only Meiji and later eras are supported; dates before Meiji 6, January 1 are not supported.

Implementation Requirements:
  This class is immutable and thread-safe.
Since:
  1.8
See Also:
  Serialized Form

### Field Summary

Fields
`static JapaneseEra` `HEISEI` The singleton instance for the 'Heisei' era (1989-01-08 - current) which has the value 2.
`static JapaneseEra` `MEIJI` The singleton instance for the 'Meiji' era (1868-01-01 - 1912-07-29) which has the value -1.
`static JapaneseEra` `SHOWA` The singleton instance for the 'Showa' era (1926-12-25 - 1989-01-07) which has the value 1.
`static JapaneseEra` `TAISHO` The singleton instance for the 'Taisho' era (1912-07-30 - 1926-12-24) which has the value 0.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`int` `getValue()` Gets the numeric era `int` value.
`static JapaneseEra` `of(int japaneseEra)` Obtains an instance of `JapaneseEra` from an `int` value.
`ValueRange` `range(TemporalField field)` Gets the range of valid values for the specified field.
`String` `toString()` Returns a string representation of the object.
`static JapaneseEra` `valueOf(String japaneseEra)` Returns the `JapaneseEra` with the name.
`static JapaneseEra[]` `values()` Returns an array of JapaneseEras.

### Methods inherited from interface java.time.chrono.Era

`adjustInto, get, getDisplayName, getLong, isSupported, query`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### HEISEI

    public static final JapaneseEra HEISEI

The singleton instance for the 'Heisei' era (1989-01-08 - current) which has the value 2.

#### MEIJI

    public static final JapaneseEra MEIJI

The singleton instance for the 'Meiji' era (1868-01-01 - 1912-07-29) which has the value -1.

#### SHOWA

    public static final JapaneseEra SHOWA

The singleton instance for the 'Showa' era (1926-12-25 - 1989-01-07) which has the value 1.

#### TAISHO

    public static final JapaneseEra TAISHO

The singleton instance for the 'Taisho' era (1912-07-30 - 1926-12-24) which has the value 0.

### Method Detail

#### of

    public static JapaneseEra of(int japaneseEra)

Obtains an instance of `JapaneseEra` from an `int` value.

The `SHOWA` era that contains 1970-01-01 (ISO calendar system) has the value 1 Later era is numbered 2 (`HEISEI`). Earlier eras are numbered 0 (`TAISHO`), -1 (`MEIJI`), only Meiji and later eras are supported.

Parameters:
  `japaneseEra` - the era to represent
Returns:
  the `JapaneseEra` singleton, not null
Throws:
  `DateTimeException` - if the value is invalid

#### valueOf

    public static JapaneseEra valueOf(String japaneseEra)

Returns the `JapaneseEra` with the name.

The string must match exactly the name of the era. (Extraneous whitespace characters are not permitted.)

Parameters:
  `japaneseEra` - the japaneseEra name; non-null
Returns:
  the `JapaneseEra` singleton, never null
Throws:
  `IllegalArgumentException` - if there is not JapaneseEra with the specified name

#### values

    public static JapaneseEra[] values()

Returns an array of JapaneseEras.

This method may be used to iterate over the JapaneseEras as follows:

     for (JapaneseEra c : JapaneseEra.values())
         System.out.println(c);

Returns:
  an array of JapaneseEras

#### getValue

    public int getValue()

Gets the numeric era `int` value.

The `SHOWA` era that contains 1970-01-01 (ISO calendar system) has the value 1. Later eras are numbered from 2 (`HEISEI`). Earlier eras are numbered 0 (`TAISHO`), -1 (`MEIJI`)).

Specified by:
  `getValue` in interface `Era`
Returns:
  the era value

#### range

    public ValueRange range(TemporalField field)

Gets the range of valid values for the specified field.

The range object expresses the minimum and maximum valid values for a field. This era is used to enhance the accuracy of the returned range. If it is not possible to return the range, because the field is not supported or for some other reason, an exception is thrown.

If the field is a `ChronoField` then the query is implemented here. The `ERA` field returns the range. All other `ChronoField` instances will throw an `UnsupportedTemporalTypeException`.

If the field is not a `ChronoField`, then the result of this method is obtained by invoking `TemporalField.rangeRefinedBy(TemporalAccessor)` passing `this` as the argument. Whether the range can be obtained is determined by the field.

The range of valid Japanese eras can change over time due to the nature of the Japanese calendar system.

Specified by:
  `range` in interface `Era`
Specified by:
  `range` in interface `TemporalAccessor`
Parameters:
  `field` - the field to query the range for, not null
Returns:
  the range of valid values for the field, not null
Throws:
  `DateTimeException` - if the range for the field cannot be obtained
  `UnsupportedTemporalTypeException` - if the unit is not supported

#### toString

    public String toString()

Description copied from class: `Object`
Returns a string representation of the object. In general, the `toString` method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method.

The `toString` method for class `Object` returns a string consisting of the name of the class of which the object is an instance, the at-sign character ``@`', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of:

>      getClass().getName() + '@' + Integer.toHexString(hashCode())

Overrides:
  `toString` in class `Object`
Returns:
  a string representation of the object.